=== debian/changelog ===
rtpengine (11.3.1.1+provoice1) jammy; urgency=medium

  * Release for ProVoice on Ubuntu 22.04 LTS

 -- Thomas Lobker <thomas@mediaserve.nl>  Fri, 07 Apr 2023 13:07:18 +0000
