=== debian/control ===
Source: rtpengine
Section: net
Priority: optional
Maintainer: Sipwise Development Team <support@sipwise.com>
Homepage: https://www.sipwise.com/
Standards-Version: 4.5.1
Build-Depends:
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 dh-sequence-dkms,
 gperf,
 libavcodec-dev (>= 6:10),
 libavfilter-dev (>= 6:10),
 libavformat-dev (>= 6:10),
 libavutil-dev (>= 6:10),
 libbcg729-dev <!pkg.rtpengine.nobcg729>,
 libbencode-perl,
 libcrypt-openssl-rsa-perl,
 libcrypt-rijndael-perl,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libdigest-crc-perl,
 libdigest-hmac-perl,
 libevent-dev (>= 2.0),
 libglib2.0-dev (>= 2.30),
 libhiredis-dev,
 libio-multiplex-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libiptc-dev,
 libjson-glib-dev,
 libjson-perl,
 libmosquitto-dev,
 libnet-interface-perl,
 libopus-dev,
 libpcap0.8-dev,
 libpcre3-dev,
 libsocket6-perl,
 libspandsp-dev,
 libssl-dev (>= 1.0.1),
 libswresample-dev (>= 6:10),
 libsystemd-dev,
 libtest2-suite-perl,
 libwebsockets-dev,
 libxmlrpc-core-c3-dev (>= 1.16.07),
 libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
 markdown,
 python3,
 python3-websockets,
 zlib1g-dev,
Testsuite: autopkgtest-pkg-dkms

Package: rtpengine-daemon
Architecture: any
Multi-Arch: foreign
Recommends:
 rtpengine-recording-daemon,
 rtpengine-utils,
Suggests:
 system-tools,
Pre-Depends:
 adduser,
 ${misc:Pre-Depends},
Depends:
 iptables,
 sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Description: proxy for RTP and media streams used in NGCP, userspace part
 This daemon handles the first stages of proxying media streams and talks to
 the kernel part of the proxy for eventual high-performance packet forwarding.

Package: rtpengine-recording-daemon
Architecture: any
Multi-Arch: foreign
Build-Profiles: <!pkg.rtpengine.no-transcoding>
Recommends:
 rtpengine-utils,
Suggests:
 system-tools,
Depends:
 nfs-common,
 rtpengine-daemon,
 sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Description: recording daemon for RTP and media streams
 This daemon handles the call recording (media intercept) component of rtpengine.

Package: rtpengine-iptables
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: IPtables extension module for the kernel-space NGCP media proxy
 Provides the IPtables extension needed to configure the mediaproxy rule.

Package: rtpengine
Architecture: all
Multi-Arch: foreign
Depends:
 rtpengine-daemon (>= ${source:Version}),
 rtpengine-iptables (>= ${source:Version}),
 rtpengine-kernel-dkms (>= ${source:Version}),
 rtpengine-recording-daemon (>= ${source:Version}),
 rtpengine-utils (>= ${source:Version}),
 ${misc:Depends},
Description: NGCP RTP/media proxy - meta package
 This is a meta package for easy installation of all four parts of the NGCP
 media proxy. It will install the user-space daemon, the kernel-space IPtables
 module, the IPtables extension module and utility scripts.

Package: rtpengine-kernel-dkms
Architecture: all
Section: kernel
Suggests:
 system-tools,
Depends:
 lsb-release,
 ${misc:Depends},
Description: IPtables kernel module for the NGCP media proxy - DKMS
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with dkms.

Package: rtpengine-utils
Architecture: all
Multi-Arch: foreign
Depends:
 libbencode-perl,
 libconfig-tiny-perl,
 libcrypt-rijndael-perl,
 libdigest-hmac-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libsocket6-perl,
 netcat-openbsd | netcat,
 ${misc:Depends},
 ${perl:Depends},
Description: scripts and Perl modules for NGCP rtpengine
 This package contains scripts and Perl modules for NGCP rtpengine
